unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, math, shellapi;

type
  Tfrm1 = class(TForm)
    dzr_grp1: TGroupBox;
    dzr_lbl1: TLabel;
    dzr_lbl2: TLabel;
    dzr_btn1: TButton;
    dzr_lbl3: TLabel;
    dzr_edt1: TEdit;
    dzr_edt2: TEdit;
    eur_grp1: TGroupBox;
    eur_edt1: TEdit;
    eur_lbl1: TLabel;
    eur_edt2: TEdit;
    eur_lbl2: TLabel;
    eur_btn1: TButton;
    eur_btn2: TButton;
    fib_grp1: TGroupBox;
    fib_lbl1: TLabel;
    fib_edt1: TEdit;
    fib_btn1: TButton;
    fib_lbl2: TLabel;
    log_grp1: TGroupBox;
    log_lbl1: TLabel;
    log_lbl2: TLabel;
    log_edt1: TEdit;
    log_edt2: TEdit;
    log_lbl3: TLabel;
    log_btn1: TButton;
    lot_grp1: TGroupBox;
    lot_btn1: TButton;
    lot_edt1: TEdit;
    lot_edt2: TEdit;
    lot_edt3: TEdit;
    lot_edt4: TEdit;
    lot_edt5: TEdit;
    lot_edt6: TEdit;
    dch: TGroupBox;
    dch_lbl1: TLabel;
    dch_edt1: TEdit;
    dch_edt2: TEdit;
    dch_lbl2: TLabel;
    dch_btn1: TButton;
    dch_btn2: TButton;
    hch_grp1: TGroupBox;
    hch_lbl1: TLabel;
    hch_lbl2: TLabel;
    hch_edt1: TEdit;
    hch_edt2: TEdit;
    hch_btn1: TButton;
    hch_btn2: TButton;
    zns_grp1: TGroupBox;
    OK: TButton;
    zns_edt1: TEdit;
    zns_lbl1: TLabel;
    zns_lbl2: TLabel;
    zns_edt2: TEdit;
    zns_lbl3: TLabel;
    zns_edt3: TEdit;
    zns_edt4: TEdit;
    zns_lbl4: TLabel;
    zns_lbl5: TLabel;
    zns_lbl6: TLabel;
    vts_grp1: TGroupBox;
    vts_lbl1: TLabel;
    procedure dzr_btn1Click(Sender: TObject);
    procedure eur_btn2Click(Sender: TObject);
    procedure eur_btn1Click(Sender: TObject);
    procedure fib_btn1Click(Sender: TObject);
    procedure log_btn1Click(Sender: TObject);
    procedure lot_btn1Click(Sender: TObject);
    procedure hch_btn1Click(Sender: TObject);
    procedure dch_btn1Click(Sender: TObject);
    procedure dch_btn2Click(Sender: TObject);
    procedure hch_btn2Click(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure vts_lbl1Click(Sender: TObject);
  end;

var
  frm1: Tfrm1;

implementation

{$R *.dfm}

{$R WindowsXP.res}

// DOWNLOADZEIT

procedure Tfrm1.dzr_btn1Click(Sender: TObject);
var
  x, y, z: extended;
const
  t = 1024;
begin
  x := strtofloat(dzr_edt1.text);
  y := strtofloat(dzr_edt1.text);
  z := x * t / y / 60;
  dzr_lbl3.caption := floattostrf(z, ffFixed, 7, 1) + ' Min';
  if z > 60 then
  begin
    z := x * t / y / 60 / 60;
    dzr_lbl3.caption := floattostrf(z, ffFixed, 7, 1) + ' Std';
  end;
end;

// EURO

function RoundUp(X: Extended): Extended;
begin
   Result := Trunc(X) + Trunc (Frac(X) * 2);
end;

function RoundX(const Value:Extended; const nk:Integer): Extended;
var
  multi: Extended;
begin
  multi := IntPower(10, nk);
  Result := RoundUp(Value*multi) / multi;
end;

procedure Tfrm1.eur_btn2Click(Sender: TObject);
begin
  eur_edt2.Text := FloatToStr(RoundX(StrToFloat(eur_edt1.Text) / 1.95583, 2));
end;

procedure Tfrm1.eur_btn1Click(Sender: TObject);
begin
  eur_edt1.Text := FloatToStr(RoundX(StrToFloat(eur_edt2.Text) * 1.95583, 2));
end;

// FIBONACCI

function fib(n: integer): Int64;
var
  I: Integer;
  A: array[0..2] of Int64;
begin
  if (n = 0) or (n = 1) then
    Result := 1
  else begin
    A[0] := 1;
    A[1] := 1;
    for I := 2 to n do
      A[I mod 3] := A[(I - 1) mod 3] + A[(I - 2) mod 3];
    Result := A[n mod 3];
  end;
end;

procedure Tfrm1.fib_btn1Click(Sender: TObject);
begin
  fib_lbl2.caption := '';
  refresh;
  fib_btn1.Enabled := false;
  try
    if strtoint(fib_edt1.text) < 0 then
      fib_lbl2.caption := 'Unberechenbar'
    else
      fib_lbl2.caption := inttostr(fib(strtoint(fib_edt1.text)));
  except
    fib_lbl2.caption := 'Unberechenbar';
  end;
  fib_btn1.Enabled := true;
end;

// LOGARTIHMUS

function Log(x, b: Real): Real;
begin
  Result := ln(x) / ln(b);
end;

procedure Tfrm1.log_btn1Click(Sender: TObject);
begin
  log_lbl3.caption := floattostr(Log(strtoint(log_edt1.text), strtoint(log_edt2.text)));
end;

// LOTTO

procedure Tfrm1.lot_btn1Click(Sender: TObject);
begin
  randomize;
  lot_edt1.Text := inttostr(random(49)+1);
  lot_edt2.Text := inttostr(random(49)+1);
  lot_edt3.Text := inttostr(random(49)+1);
  lot_edt4.Text := inttostr(random(49)+1);
  lot_edt5.Text := inttostr(random(49)+1);
  lot_edt6.Text := inttostr(random(49)+1);
  if ((lot_edt1.text=lot_edt2.Text) or (lot_edt1.text=lot_edt3.Text) or
    (lot_edt1.text=lot_edt4.Text) or (lot_edt1.text=lot_edt5.Text) or
    (lot_edt1.text=lot_edt6.Text)) or ((lot_edt2.text=lot_edt1.Text) or
    (lot_edt2.text=lot_edt3.Text) or (lot_edt2.text=lot_edt4.Text) or
    (lot_edt2.text=lot_edt5.Text) or (lot_edt2.text=lot_edt6.Text)) or
    ((lot_edt3.text=lot_edt1.Text) or (lot_edt3.text=lot_edt2.Text) or
    (lot_edt3.text=lot_edt4.Text) or (lot_edt3.text=lot_edt5.Text) or
    (lot_edt3.text=lot_edt6.Text)) or ((lot_edt4.text=lot_edt1.Text) or
    (lot_edt4.text=lot_edt2.Text) or (lot_edt4.text=lot_edt3.Text) or
    (lot_edt4.text=lot_edt5.Text) or (lot_edt4.text=lot_edt6.Text)) or
    ((lot_edt5.text=lot_edt1.Text) or (lot_edt5.text=lot_edt2.Text) or
    (lot_edt5.text=lot_edt3.Text) or (lot_edt5.text=lot_edt4.Text) or
    (lot_edt5.text=lot_edt6.Text)) or ((lot_edt6.text=lot_edt1.Text) or
    (lot_edt6.text=lot_edt2.Text) or (lot_edt6.text=lot_edt3.Text) or
    (lot_edt6.text=lot_edt4.Text) or (lot_edt6.text=lot_edt5.Text)) then
  begin
    lot_btn1.Click;
    exit;
  end;
end;

// DEC <> CHR (ASCII)

procedure Tfrm1.dch_btn1Click(Sender: TObject);
begin
  dch_edt2.text := chr(strtoint(dch_edt1.text));
end;

procedure Tfrm1.dch_btn2Click(Sender: TObject);
var
  txt: string;
begin
  txt := dch_edt2.text;
  dch_edt1.text := IntToStr(Ord(txt[1]));
end;

// HEX <> CHR (ASCII)

function HexToInt(HexNum: string): LongInt;
begin
  Result:=StrToInt('$' + HexNum);
end;

procedure Tfrm1.hch_btn1Click(Sender: TObject);
begin
  hch_edt2.text := chr(HexToInt(hch_edt1.text));
end;

procedure Tfrm1.hch_btn2Click(Sender: TObject);
var
  txt: string;
begin
  txt := hch_edt2.text;
  hch_edt1.text := IntToHex(Ord(txt[1]), 2);
end;

// ZINSBERECHNUNG

procedure Tfrm1.OKClick(Sender: TObject);
var
  ProzentNachl, Zinssatz, Gesamtkosten, Monatsrate: extended;
  Lauftzeit: Integer;
begin
  try
    Gesamtkosten := StrToFloat(zns_edt1.Text);
    ProzentNachl := StrToFloat(zns_edt2.Text) / 100;
    Lauftzeit := StrToInt(zns_edt3.Text) * 12;
    Zinssatz := StrToFloat(zns_edt4.Text) / 100;
  except
    exit;
  end;
  Monatsrate := -Payment(Zinssatz / 12, Lauftzeit, Gesamtkosten *
                (1 - Prozentnachl), 0, ptStartOfPeriod);
  zns_lbl6.caption := FloatToStrF(Monatsrate, ffCurrency, 18, 2);
end;

procedure Tfrm1.vts_lbl1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://www.viathinksoft.de/', '', '', 1);
end;

end.
